Index: src/data/format.def
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/format.def,v
retrieving revision 1.3
diff -u -p -r1.3 format.def
--- src/data/format.def	18 Jul 2006 04:57:01 -0000	1.3
+++ src/data/format.def	1 Nov 2006 04:17:16 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -17,43 +17,53 @@
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
    02110-1301, USA. */
 
-/* Numeric and string formats. */
-DEFFMT (FMT_F,            "F",         2,  1,  40,  1,   40, 0001, FMT_F, 5)
-DEFFMT (FMT_N,		  "N",         2,  1,  40,  1,   40, 0011, FMT_F, 16)
-DEFFMT (FMT_E,		  "E",         2,  1,  40,  6,   40, 0001, FMT_E, 17)
-DEFFMT (FMT_COMMA,	  "COMMA",     2,  1,  40,  1,   40, 0001, FMT_COMMA, 3)
-DEFFMT (FMT_DOT,	  "DOT",       2,  1,  40,  1,   40, 0001, FMT_DOT, 32)
-DEFFMT (FMT_DOLLAR,	  "DOLLAR",    2,  1,  40,  2,   40, 0001, FMT_DOLLAR, 4)
-DEFFMT (FMT_PCT,	  "PCT",       2,  1,  40,  2,   40, 0001, FMT_PCT, 31)
-DEFFMT (FMT_Z,		  "Z",         2,  1,  40,  1,   40, 0011, FMT_F, 15)
-DEFFMT (FMT_A,		  "A",         1,  1, MAX_STRING,  1,  MAX_STRING, 0004, FMT_A, 1)
-DEFFMT (FMT_AHEX,	  "AHEX",      1,  2, 510,  2,  510, 0006, FMT_A, 2)
-DEFFMT (FMT_IB,		  "IB",        2,  1,   8,  1,    8, 0010, FMT_F, 6)
-DEFFMT (FMT_P,		  "P",         2,  1,  16,  1,   16, 0011, FMT_F, 8)
-DEFFMT (FMT_PIB,	  "PIB",       2,  1,   8,  1,    8, 0010, FMT_F, 9)
-DEFFMT (FMT_PIBHEX,	  "PIBHEX",    2,  2,  16,  2,   16, 0002, FMT_F, 7)
-DEFFMT (FMT_PK,		  "PK",        2,  1,  16,  1,   16, 0010, FMT_F, 10)
-DEFFMT (FMT_RB,		  "RB",        1,  2,   8,  2,    8, 0002, FMT_F, 11)
-DEFFMT (FMT_RBHEX,	  "RBHEX",     1,  4,  16,  4,   16, 0002, FMT_F, 12)
-			  					    
-/* Custom currency. */	  					    
-DEFFMT (FMT_CCA,	  "CCA",       2, -1,  -1,  1,   40, 0020, FMT_CCA, 33)
-DEFFMT (FMT_CCB,	  "CCB",       2, -1,  -1,  1,   40, 0020, FMT_CCB, 34)
-DEFFMT (FMT_CCC,	  "CCC",       2, -1,  -1,  1,   40, 0020, FMT_CCC, 35)
-DEFFMT (FMT_CCD,	  "CCD",       2, -1,  -1,  1,   40, 0020, FMT_CCD, 36)
-DEFFMT (FMT_CCE,	  "CCE",       2, -1,  -1,  1,   40, 0020, FMT_CCE, 37)
-			  					     
-/* Date/time formats. */  					     
-DEFFMT (FMT_DATE,	  "DATE",      1,  9,  40,  9,   40, 0001, FMT_DATE, 20)
-DEFFMT (FMT_EDATE,	  "EDATE",     1,  8,  40,  8,   40, 0001, FMT_EDATE, 38)
-DEFFMT (FMT_SDATE,	  "SDATE",     1,  8,  40,  8,   40, 0001, FMT_SDATE, 39)
-DEFFMT (FMT_ADATE,	  "ADATE",     1,  8,  40,  8,   40, 0001, FMT_ADATE, 23)
-DEFFMT (FMT_JDATE,	  "JDATE",     1,  5,  40,  5,   40, 0001, FMT_JDATE, 24)
-DEFFMT (FMT_QYR,	  "QYR",       1,  4,  40,  6,   40, 0001, FMT_QYR, 29)
-DEFFMT (FMT_MOYR,	  "MOYR",      1,  6,  40,  6,   40, 0001, FMT_MOYR, 28)
-DEFFMT (FMT_WKYR,	  "WKYR",      1,  6,  40,  8,   40, 0001, FMT_WKYR, 30)
-DEFFMT (FMT_DATETIME,	  "DATETIME",  2, 17,  40, 17,   40, 0001, FMT_DATETIME, 22)
-DEFFMT (FMT_TIME,	  "TIME",      2,  5,  40,  5,   40, 0001, FMT_TIME, 21)
-DEFFMT (FMT_DTIME,	  "DTIME",     2, 11,  40,  8,   40, 0001, FMT_DTIME, 25)
-DEFFMT (FMT_WKDAY,	  "WKDAY",     1,  2,  40,  2,   40, 0001, FMT_WKDAY, 26)
-DEFFMT (FMT_MONTH,	  "MONTH",     1,  3,  40,  3,   40, 0001, FMT_MONTH, 27)
+/* Basic numeric formats. */
+FMT (F,        number,  1,  1,  5, FMT_CAT_BASIC)
+FMT (COMMA,    number,  1,  1,  3, FMT_CAT_BASIC)
+FMT (DOT,      number,  1,  1, 32, FMT_CAT_BASIC)
+FMT (DOLLAR,   number,  1,  2,  4, FMT_CAT_BASIC)
+FMT (PCT,      number,  1,  2, 31, FMT_CAT_BASIC)
+FMT (E,        number,  1,  6, 17, FMT_CAT_BASIC)
+
+/* Custom currency formats. */
+FMT (CCA,      number, -1,  2, 33, FMT_CAT_CUSTOM)
+FMT (CCB,      number, -1,  2, 34, FMT_CAT_CUSTOM)
+FMT (CCC,      number, -1,  2, 35, FMT_CAT_CUSTOM)
+FMT (CCD,      number, -1,  2, 36, FMT_CAT_CUSTOM)
+FMT (CCE,      number, -1,  2, 37, FMT_CAT_CUSTOM)
+
+/* Legacy numeric formats. */
+FMT (N,        N,       1,  1, 16, FMT_CAT_LEGACY)
+FMT (Z,        Z,       1,  1, 16, FMT_CAT_LEGACY)
+
+/* Binary and hexadecimal formats. */
+FMT (P,        P,       1,  1,  8, FMT_CAT_BINARY)
+FMT (PK,       PK,      1,  1, 10, FMT_CAT_BINARY)
+FMT (IB,       IB,      1,  1,  6, FMT_CAT_BINARY)
+FMT (PIB,      PIB,     1,  1,  9, FMT_CAT_BINARY)
+FMT (PIBHEX,   PIBHEX,  2,  2,  7, FMT_CAT_HEXADECIMAL)
+FMT (RB,       RB,      2,  2, 11, FMT_CAT_BINARY)
+FMT (RBHEX,    RBHEX,   4,  4, 12, FMT_CAT_HEXADECIMAL)
+
+/* Time and date formats. */
+FMT (DATE,     date,	8,  9, 20, FMT_CAT_DATE)
+FMT (ADATE,    date,	8,  8, 23, FMT_CAT_DATE)
+FMT (EDATE,    date,	8,  8, 38, FMT_CAT_DATE)
+FMT (JDATE,    date,	5,  5, 24, FMT_CAT_DATE)
+FMT (SDATE,    date,	8,  8, 39, FMT_CAT_DATE)
+FMT (QYR,      date,	4,  6, 29, FMT_CAT_DATE)
+FMT (MOYR,     date,	6,  6, 28, FMT_CAT_DATE)
+FMT (WKYR,     date,	6,  8, 30, FMT_CAT_DATE)
+FMT (DATETIME, date,    7, 17, 22, FMT_CAT_DATE)
+FMT (TIME,     date,	5,  5, 21, FMT_CAT_TIME)
+FMT (DTIME,    date,	8,  8, 25, FMT_CAT_TIME)
+
+/* Date component formats. */
+FMT (WKDAY,    WKDAY,   2,  2, 26, FMT_CAT_DATE_COMPONENT)
+FMT (MONTH,    MONTH,   3,  3, 27, FMT_CAT_DATE_COMPONENT)
+
+/* String formats. */
+FMT (A,        A,       1,  1,  1, FMT_CAT_STRING)
+FMT (AHEX,     AHEX,    2,  2,  2, FMT_CAT_STRING)
+
+#undef FMT
Index: src/data/format.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/format.h,v
retrieving revision 1.7
diff -u -p -r1.7 format.h
--- src/data/format.h	1 Nov 2006 03:36:10 -0000	1.7
+++ src/data/format.h	1 Nov 2006 04:17:16 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -17,65 +17,133 @@
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
    02110-1301, USA. */
 
-#if !format_h
-#define format_h 1
+#ifndef FORMAT_H
+#define FORMAT_H 1
 
 /* Display format types. */
 
 #include <stdbool.h>
+#include <stddef.h>
+#include <libpspp/str.h>
 
-/* See the definitions of these functions and variables when modifying
-   this list:
-   misc.c:convert_fmt_ItoO()
-   sys-file-reader.c:parse_format_spec()
-   data-in.c:parse_string_as_format() */
-#define DEFFMT(LABEL, NAME, N_ARGS, IMIN_W, IMAX_W, OMIN_W, OMAX_W,	\
-	       CAT, OUTPUT, SPSS_FMT)					\
-	LABEL,
-enum
+/* Format type categories. */
+enum fmt_category 
   {
+    /* Numeric formats. */
+    FMT_CAT_BASIC          = 0x001,     /* Basic numeric formats. */
+    FMT_CAT_CUSTOM         = 0x002,     /* Custom currency formats. */
+    FMT_CAT_LEGACY         = 0x004,     /* Legacy numeric formats. */
+    FMT_CAT_BINARY         = 0x008,     /* Binary formats. */
+    FMT_CAT_HEXADECIMAL    = 0x010,     /* Hexadecimal formats. */
+    FMT_CAT_DATE           = 0x020,     /* Date formats. */
+    FMT_CAT_TIME           = 0x040,     /* Time formats. */
+    FMT_CAT_DATE_COMPONENT = 0x080,     /* Date component formats. */
+
+    /* String formats. */
+    FMT_CAT_STRING         = 0x100      /* String formats. */
+  };
+
+enum fmt_type
+  {
+#define FMT(NAME, METHOD, IMIN, OMIN, IO, CATEGORY) FMT_##NAME,
 #include "format.def"
-    FMT_NUMBER_OF_FORMATS
+    FMT_NUMBER_OF_FORMATS,
   };
-#undef DEFFMT
 
 /* Length of longest format specifier name,
    not including terminating null. */
 #define FMT_TYPE_LEN_MAX 8
 
-/* Describes one of the display formats above. */
-struct fmt_desc
-  {
-    char name[FMT_TYPE_LEN_MAX + 1]; /* Name, in all caps. */
-    int n_args;			/* 1=width; 2=width.decimals. */
-    int Imin_w, Imax_w;		/* Bounds on input width. */
-    int Omin_w, Omax_w;		/* Bounds on output width. */
-    int cat;			/* Categories. */
-    int output;			/* Output format. */
-    int spss;			/* Equivalent SPSS output format. */
-  };
-
-/* Display format categories. */
-enum
-  {
-    FCAT_BLANKS_SYSMIS = 001,	/* 1=All-whitespace means SYSMIS. */
-    FCAT_EVEN_WIDTH = 002,	/* 1=Width must be even. */
-    FCAT_STRING = 004,		/* 1=String input/output format. */
-    FCAT_SHIFT_DECIMAL = 010,	/* 1=Automatically shift decimal point
-				   on output--used for fixed-point
-				   formats. */
-    FCAT_OUTPUT_ONLY = 020	/* 1=This is not an input format. */
-  };
+/* Length of longest string representation of fmt_spec,
+   not including terminating null. */
+#define FMT_STRING_LEN_MAX 32
 
 /* Display format. */
 struct fmt_spec
   {
-    int type;			/* One of the above constants. */
+    enum fmt_type type;		/* One of FMT_*. */
     int w;			/* Width. */
     int d;			/* Number of implied decimal places. */
   };
 
+union value;
 
+/* Initialization. */
+void fmt_init (void);
+void fmt_done (void);
+
+/* Constructing formats. */
+struct fmt_spec fmt_for_input (enum fmt_type, int w, int d) PURE_FUNCTION;
+struct fmt_spec fmt_for_output (enum fmt_type, int w, int d) PURE_FUNCTION;
+struct fmt_spec fmt_for_output_from_input (const struct fmt_spec *);
+
+/* Verifying formats. */
+bool fmt_check (const struct fmt_spec *, bool for_input);
+bool fmt_check_input (const struct fmt_spec *);
+bool fmt_check_output (const struct fmt_spec *);
+bool fmt_check_type_compat (const struct fmt_spec *, int var_type);
+bool fmt_check_width_compat (const struct fmt_spec *, int width);
+
+/* Working with formats. */
+int fmt_var_width (const struct fmt_spec *);
+char *fmt_to_string (const struct fmt_spec *, char s[FMT_STRING_LEN_MAX + 1]);
+
+/* Format types. */
+const char *fmt_name (enum fmt_type) PURE_FUNCTION;
+bool fmt_from_name (const char *name, enum fmt_type *);
+
+bool fmt_takes_decimals (enum fmt_type) PURE_FUNCTION;
+
+int fmt_min_input_width (enum fmt_type) PURE_FUNCTION;
+int fmt_max_input_width (enum fmt_type) PURE_FUNCTION;
+int fmt_max_input_decimals (enum fmt_type, int width) PURE_FUNCTION;
+int fmt_min_output_width (enum fmt_type) PURE_FUNCTION;
+int fmt_max_output_width (enum fmt_type) PURE_FUNCTION;
+int fmt_max_output_decimals (enum fmt_type, int width) PURE_FUNCTION;
+int fmt_step_width (enum fmt_type) PURE_FUNCTION;
+
+bool fmt_is_string (enum fmt_type) PURE_FUNCTION;
+bool fmt_is_numeric (enum fmt_type) PURE_FUNCTION;
+enum fmt_category fmt_get_category (enum fmt_type) PURE_FUNCTION;
+
+enum fmt_type fmt_input_to_output (enum fmt_type) PURE_FUNCTION;
+
+int fmt_to_io (enum fmt_type) PURE_FUNCTION;
+bool fmt_from_io (int io, enum fmt_type *);
+
+bool fmt_usable_for_input (enum fmt_type) PURE_FUNCTION;
+const char *fmt_date_template (enum fmt_type) PURE_FUNCTION;
+
+/* Maximum length of prefix or suffix string in
+   struct fmt_number_style. */
+#define FMT_STYLE_AFFIX_MAX 16
+
+/* A numeric output style. */
+struct fmt_number_style
+  {
+    struct substring neg_prefix;      /* Negative prefix. */
+    struct substring prefix;          /* Prefix. */
+    struct substring suffix;          /* Suffix. */
+    struct substring neg_suffix;      /* Negative suffix. */
+    char decimal;                     /* Decimal point: '.' or ','. */
+    char grouping;                    /* Grouping character: ',', '.', or 0. */
+  };
+
+struct fmt_number_style *fmt_number_style_create (void);
+void fmt_number_style_destroy (struct fmt_number_style *);
+
+const struct fmt_number_style *fmt_get_style (enum fmt_type);
+void fmt_set_style (enum fmt_type, struct fmt_number_style *);
+
+int fmt_affix_width (const struct fmt_number_style *);
+int fmt_neg_affix_width (const struct fmt_number_style *);
+
+int fmt_decimal_char (enum fmt_type);
+int fmt_grouping_char (enum fmt_type);
+
+void fmt_set_decimal (char);
+
+/* Alignment of data for display. */
 enum alignment 
   {
     ALIGN_LEFT = 0,
@@ -84,7 +152,7 @@ enum alignment 
     n_ALIGN
   };
 
-
+/* How data is measured. */
 enum measure
   {
     MEASURE_NOMINAL=1,
@@ -95,34 +163,9 @@ enum measure
 
 bool measure_is_valid(enum measure m);
 bool alignment_is_valid(enum alignment a);
+
+#include <libpspp/legacy-encoding.h>
 
-
-/* Descriptions of all the display formats above. */
-extern const struct fmt_desc formats[];
-
-union value;
-
-/* Maximum length of formatted value, in characters. */
-#define MAX_FORMATTED_LEN 256
-
-/* Common formats. */
-extern const struct fmt_spec f8_2;      /* F8.2. */
-
-int check_input_specifier (const struct fmt_spec *spec, int emit_error);
-int check_output_specifier (const struct fmt_spec *spec, int emit_error);
-bool check_specifier_type (const struct fmt_spec *, int type, bool emit_error);
-bool check_specifier_width (const struct fmt_spec *,
-                            int width, bool emit_error);
-void convert_fmt_ItoO (const struct fmt_spec *input, struct fmt_spec *output);
-int get_format_var_width (const struct fmt_spec *);
-int parse_string_as_format (const char *s, int len, const struct fmt_spec *fp,
-			    int fc, union value *v);
-int translate_fmt (int spss);
 bool data_out (char *s, const struct fmt_spec *fp, const union value *v);
-bool fmt_type_from_string (const char *name, int *type);
-char *fmt_to_string (const struct fmt_spec *);
-struct fmt_spec make_input_format (int type, int w, int d);
-struct fmt_spec make_output_format (int type, int w, int d);
-bool fmt_is_binary (int type);
 
-#endif /* !format_h */
+#endif /* format.h */
Index: src/data/por-file-reader.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/por-file-reader.c,v
retrieving revision 1.11
diff -u -p -r1.11 por-file-reader.c
--- src/data/por-file-reader.c	9 Jun 2006 22:51:23 -0000	1.11
+++ src/data/por-file-reader.c	1 Nov 2006 04:17:17 -0000
@@ -468,18 +468,25 @@ static void
 convert_format (struct pfm_reader *r, const int portable_format[3],
                 struct fmt_spec *format, struct variable *v)
 {
-  format->type = translate_fmt (portable_format[0]);
-  if (format->type == -1)
+  bool ok;
+
+  if (!fmt_from_io (portable_format[0], &format->type))
     error (r, _("%s: Bad format specifier byte (%d)."),
            v->name, portable_format[0]);
   format->w = portable_format[1];
   format->d = portable_format[2];
 
-  if (!check_output_specifier (format, false)
-      || !check_specifier_width (format, v->width, false))
-    error (r, _("%s variable %s has invalid format specifier %s."),
-           v->type == NUMERIC ? _("Numeric") : _("String"),
-           v->name, fmt_to_string (format));
+  msg_disable ();
+  ok = fmt_check_output (format) && fmt_check_width_compat (format, v->width);
+  msg_enable ();
+
+  if (!ok)
+    {
+      char fmt_string[FMT_STRING_LEN_MAX + 1];
+      error (r, _("%s variable %s has invalid format specifier %s."),
+             v->type == NUMERIC ? _("Numeric") : _("String"),
+             v->name, fmt_to_string (format, fmt_string)); 
+    }
 }
 
 static union value parse_value (struct pfm_reader *, struct variable *);
Index: src/data/por-file-writer.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/por-file-writer.c,v
retrieving revision 1.4
diff -u -p -r1.4 por-file-writer.c
--- src/data/por-file-writer.c	17 Apr 2006 01:54:15 -0000	1.4
+++ src/data/por-file-writer.c	1 Nov 2006 04:17:19 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -282,7 +282,7 @@ write_version_data (struct pfm_writer *w
 static void
 write_format (struct pfm_writer *w, struct fmt_spec *f)
 {
-  write_int (w, formats[f->type].spss);
+  write_int (w, fmt_to_io (f->type));
   write_int (w, f->w);
   write_int (w, f->d);
 }
Index: src/data/settings.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/settings.c,v
retrieving revision 1.3
diff -u -p -r1.3 settings.c
--- src/data/settings.c	30 May 2006 12:01:33 -0000	1.3
+++ src/data/settings.c	1 Nov 2006 04:17:19 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -33,9 +33,6 @@ static bool long_view = false;
 
 static bool safer_mode = false;
 
-static char decimal = '.';
-static char grouping = ',';
-
 static bool echo = false;
 static bool include = true;
 
@@ -64,16 +61,6 @@ static size_t workspace = 4L * 1024 * 10
 
 static struct fmt_spec default_format = {FMT_F, 8, 2};
 
-#define CC_INITIALIZER {"-", "", "", "", '.', ','}
-static struct custom_currency cc[CC_CNT] = 
-  {
-    CC_INITIALIZER,
-    CC_INITIALIZER,
-    CC_INITIALIZER,
-    CC_INITIALIZER,
-    CC_INITIALIZER,
-  };
-
 static bool testing_mode = false;
 
 static int global_algorithm = ENHANCED;
@@ -192,41 +179,6 @@ set_safer_mode (void)
   safer_mode = true;
 }
 
-/* The character used for a decimal point: ',' or '.'.  Only
-   respected for data input and output. */
-char 
-get_decimal (void)
-{
-  return decimal;
-}
-
-/* Sets the character used for a decimal point, which must be
-   either ',' or '.'. */
-void
-set_decimal (char decimal_) 
-{
-  assert (decimal_ == '.' || decimal_ == ',');
-  decimal = decimal_;
-}
-
-/* The character used for grouping in numbers: '.' or ','; the
-   opposite of set_decimal.  Only used in COMMA data input and
-   output. */
-char
-get_grouping (void)
-{
-  return grouping;
-}
-
-/* Sets the character used for grouping, which must be either ','
-   or '.'. */
-void
-set_grouping (char grouping_) 
-{
-  assert (grouping_ == '.' || grouping_ == ',');
-  grouping = grouping_;
-}
- 
 /* Echo commands to the listing file/printer? */
 bool
 get_echo (void)
@@ -466,22 +418,6 @@ set_format (const struct fmt_spec *defau
   default_format = *default_format_;
 }
 
-/* Gets the custom currency specification with the given IDX. */
-const struct custom_currency *
-get_cc (int idx)
-{
-  assert (idx >= 0 && idx < CC_CNT);
-  return &cc[idx];
-}
-
-/* Gets custom currency specification IDX to CC. */
-void
-set_cc (int idx, const struct custom_currency *cc_) 
-{
-  assert (idx >= 0 && idx < CC_CNT);
-  cc[idx] = *cc_;
-}
-
 /* Are we in testing mode?  (e.g. --testing-mode command line
    option) */
 bool
Index: src/data/settings.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/settings.h,v
retrieving revision 1.1
diff -u -p -r1.1 settings.h
--- src/data/settings.h	4 Mar 2006 01:11:57 -0000	1.1
+++ src/data/settings.h	1 Nov 2006 04:17:19 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -45,11 +45,6 @@ void set_viewwidth (int);
 bool get_safer_mode (void);
 void set_safer_mode (void);
 
-char get_decimal (void);
-void set_decimal (char);
-char get_grouping (void);
-void set_grouping (char);
-
 bool get_echo (void);
 void set_echo (bool);
 bool get_include (void);
@@ -94,24 +89,6 @@ void set_workspace (size_t);
 const struct fmt_spec *get_format (void);
 void set_format (const struct fmt_spec *);
 
-/* Maximum number of custom currency specifications */
-#define CC_CNT 5
-
-/* One custom currency specification. */
-#define CC_WIDTH 16
-struct custom_currency
-  {
-    char neg_prefix[CC_WIDTH];	/* Negative prefix. */
-    char prefix[CC_WIDTH];	/* Prefix. */
-    char suffix[CC_WIDTH];	/* Suffix. */
-    char neg_suffix[CC_WIDTH];	/* Negative suffix. */
-    char decimal;		/* Decimal point. */
-    char grouping;		/* Grouping character. */
-  };
-
-const struct custom_currency *get_cc (int idx);
-void set_cc (int idx, const struct custom_currency *);
-
 bool get_testing_mode (void);
 void set_testing_mode (bool);
 
Index: src/data/sys-file-reader.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/sys-file-reader.c,v
retrieving revision 1.24
diff -u -p -r1.24 sys-file-reader.c
--- src/data/sys-file-reader.c	29 Oct 2006 09:51:36 -0000	1.24
+++ src/data/sys-file-reader.c	1 Nov 2006 04:17:19 -0000
@@ -1208,28 +1208,35 @@ static int
 parse_format_spec (struct sfm_reader *r, int32_t s,
                    struct fmt_spec *f, const struct variable *v)
 {
-  f->type = translate_fmt ((s >> 16) & 0xff);
-  if (f->type == -1)
+  bool ok;
+  
+  if (!fmt_from_io ((s >> 16) & 0xff, &f->type))
     lose ((ME, _("%s: Bad format specifier byte (%d)."),
 	   fh_get_file_name (r->fh), (s >> 16) & 0xff));
   f->w = (s >> 8) & 0xff;
   f->d = s & 0xff;
 
-  if ((v->type == ALPHA) ^ ((formats[f->type].cat & FCAT_STRING) != 0))
+  if ((v->type == ALPHA) ^ (fmt_is_string (f->type) != 0))
     lose ((ME, _("%s: %s variable %s has %s format specifier %s."),
 	   fh_get_file_name (r->fh),
            v->type == ALPHA ? _("String") : _("Numeric"),
 	   v->name,
-	   formats[f->type].cat & FCAT_STRING ? _("string") : _("numeric"),
-	   formats[f->type].name));
+	   fmt_is_string (f->type) ? _("string") : _("numeric"),
+	   fmt_name (f->type)));
 
-  if (!check_output_specifier (f, false)
-      || !check_specifier_width (f, v->width, false)) 
+  msg_disable ();
+  ok = fmt_check_output (f) && fmt_check_width_compat (f, v->width);
+  msg_enable ();
+  
+  if (!ok) 
     {
+      char fmt_string[FMT_STRING_LEN_MAX + 1];
       msg (ME, _("%s variable %s has invalid format specifier %s."),
            v->type == NUMERIC ? _("Numeric") : _("String"),
-           v->name, fmt_to_string (f));
-      *f = v->type == NUMERIC ? f8_2 : make_output_format (FMT_A, v->width, 0);
+           v->name, fmt_to_string (f, fmt_string));
+      *f = (v->type == NUMERIC
+            ? fmt_for_output (FMT_F, 8, 2) 
+            : fmt_for_output (FMT_A, v->width, 0));
     }
   return 1;
 
Index: src/data/sys-file-writer.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/sys-file-writer.c,v
retrieving revision 1.14
diff -u -p -r1.14 sys-file-writer.c
--- src/data/sys-file-writer.c	29 Oct 2006 11:16:07 -0000	1.14
+++ src/data/sys-file-writer.c	1 Nov 2006 04:17:19 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -18,31 +18,35 @@
    02110-1301, USA. */
 
 #include <config.h>
+
 #include "sys-file-writer.h"
 #include "sfm-private.h"
-#include <libpspp/message.h>
-#include <stdlib.h>
+
 #include <ctype.h>
 #include <errno.h>
 #include <fcntl.h>
+#include <stdlib.h>
 #include <sys/stat.h>
 #include <time.h>
 #include <unistd.h>
+
 #include <libpspp/alloc.h>
-#include "case.h"
-#include "dictionary.h"
-#include <libpspp/message.h>
-#include "file-handle-def.h"
 #include <libpspp/hash.h>
 #include <libpspp/magic.h>
+#include <libpspp/message.h>
 #include <libpspp/misc.h>
-#include "settings.h"
-#include "stat-macros.h"
 #include <libpspp/str.h>
+#include <libpspp/version.h>
+
+#include "case.h"
+#include "dictionary.h"
+#include "file-handle-def.h"
+#include "settings.h"
 #include "value-labels.h"
 #include "variable.h"
-#include <libpspp/version.h>
-#include <minmax.h>
+
+#include "stat-macros.h"
+#include "minmax.h"
 
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
@@ -437,8 +441,8 @@ write_header (struct sfm_writer *w, cons
 static inline void
 write_format_spec (const struct fmt_spec *src, int32_t *dest)
 {
-  assert(check_output_specifier(src, true));
-  *dest = (formats[src->type].spss << 16) | (src->w << 8) | src->d;
+  assert (fmt_check_output (src));
+  *dest = (fmt_to_io (src->type) << 16) | (src->w << 8) | src->d;
 }
 
 /* Write the variable record(s) for primary variable P and secondary
Index: src/language/data-io/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/ChangeLog,v
retrieving revision 1.30
diff -u -p -r1.30 ChangeLog
--- src/language/data-io/ChangeLog	1 Nov 2006 02:22:35 -0000	1.30
+++ src/language/data-io/ChangeLog	1 Nov 2006 04:17:20 -0000
@@ -1,3 +1,18 @@
+Tue Oct 31 20:04:06 2006  Ben Pfaff  <blp@gnu.org>
+
+	* placement-parser.c: (PRS_TYPE_T) Now that struct fmt_spec uses
+	an enum fmt_type for its type member, we can't depend on the
+	ability to put negative values into that member as out-of-band
+	values, because enum fmt_type might be an unsigned type.  So use
+	values around SCHAR_MAX instead, because we know that SCHAR_MAX
+	will fit into any type, signed or unsigned, and there aren't
+	nearly that many format types.
+	(parse_var_placements) Add for_input parameter to specify whether
+	we're parsing input or output formats.  Update all callers.
+	(fixed_parse_columns) Ditto.
+	(fixed_parse_fortran) Ditto.
+	
+
 Tue Oct 31 18:21:48 2006  Ben Pfaff  <blp@gnu.org>
 
 	* print-space.c (print_space_trns_proc): Let dfm_put_record add
Index: src/language/data-io/data-list.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/data-list.c,v
retrieving revision 1.22
diff -u -p -r1.22 data-list.c
--- src/language/data-io/data-list.c	26 Oct 2006 06:16:36 -0000	1.22
+++ src/language/data-io/data-list.c	1 Nov 2006 04:17:20 -0000
@@ -302,7 +302,8 @@ parse_fixed (struct dictionary *dict, 
       /* Parse everything. */
       if (!parse_record_placement (&record, &column)
           || !parse_DATA_LIST_vars_pool (tmp_pool, &names, &name_cnt, PV_NONE)
-          || !parse_var_placements (tmp_pool, name_cnt, &formats, &format_cnt))
+          || !parse_var_placements (tmp_pool, name_cnt, true,
+                                    &formats, &format_cnt))
         return false;
 
       /* Create variables and var specs. */
@@ -318,13 +319,12 @@ parse_fixed (struct dictionary *dict, 
             name = names[name_idx++];
 
             /* Create variable. */
-            width = get_format_var_width (f);
+            width = fmt_var_width (f);
             v = dict_create_var (dict, name, width);
             if (v != NULL)
               {
                 /* Success. */
-                struct fmt_spec output;
-                convert_fmt_ItoO (f, &output);
+                struct fmt_spec output = fmt_for_output_from_input (f);
                 v->print = output;
                 v->write = output;
               }
@@ -415,11 +415,13 @@ dump_fixed_table (const struct ll_list *
   row = 1;
   ll_for_each (spec, struct dls_var_spec, ll, specs)
     {
+      char fmt_string[FMT_STRING_LEN_MAX + 1];
       tab_text (t, 0, row, TAB_LEFT, spec->name);
       tab_text (t, 1, row, TAT_PRINTF, "%d", spec->record);
       tab_text (t, 2, row, TAT_PRINTF, "%3d-%3d",
                 spec->first_column, spec->first_column + spec->input.w - 1);
-      tab_text (t, 3, row, TAB_LEFT | TAB_FIX, fmt_to_string (&spec->input));
+      tab_text (t, 3, row, TAB_LEFT | TAB_FIX,
+                fmt_to_string (&spec->input, fmt_string));
       row++;
     }
 
@@ -451,15 +453,15 @@ parse_free (struct dictionary *dict, str
       if (lex_match ('('))
 	{
 	  if (!parse_format_specifier (&input)
-              || !check_input_specifier (&input, 1)
+              || !fmt_check_input (&input)
               || !lex_force_match (')')) 
             return NULL;
-	  convert_fmt_ItoO (&input, &output);
+	  output = fmt_for_output_from_input (&input);
 	}
       else
 	{
 	  lex_match ('*');
-          input = make_input_format (FMT_F, 8, 0);
+          input = fmt_for_input (FMT_F, 8, 0);
 	  output = *get_format ();
 	}
 
@@ -468,8 +470,7 @@ parse_free (struct dictionary *dict, str
           struct dls_var_spec *spec;
 	  struct variable *v;
 
-	  v = dict_create_var (dict, name[i],
-                               get_format_var_width (&input));
+	  v = dict_create_var (dict, name[i], fmt_var_width (&input));
 	  if (v == NULL)
 	    {
 	      msg (SE, _("%s is a duplicate variable name."), name[i]);
@@ -509,12 +510,13 @@ dump_free_table (const struct data_list_
   tab_box (t, TAL_1, TAL_1, TAL_0, TAL_1, 0, 0, 1, spec_cnt);
   tab_hline (t, TAL_2, 0, 1, 1);
   tab_dim (t, tab_natural_dimensions);
-
   row = 1;
   ll_for_each (spec, struct dls_var_spec, ll, &dls->specs)
     {
+      char str[FMT_STRING_LEN_MAX + 1];
       tab_text (t, 0, row, TAB_LEFT, spec->name);
-      tab_text (t, 1, row, TAB_LEFT | TAB_FIX, fmt_to_string (&spec->input));
+      tab_text (t, 1, row, TAB_LEFT | TAB_FIX,
+                fmt_to_string (&spec->input, str));
       row++;
     }
 
@@ -740,7 +742,7 @@ read_from_data_list_list (const struct d
 		 spec->name);
           ll_for_each_continue (spec, struct dls_var_spec, ll, &dls->specs)
             {
-              int width = get_format_var_width (&spec->input);
+              int width = fmt_var_width (&spec->input);
               if (width == 0)
                 case_data_rw (c, spec->fv)->f = SYSMIS;
               else
Index: src/language/data-io/get.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/get.c,v
retrieving revision 1.19
diff -u -p -r1.19 get.c
--- src/language/data-io/get.c	26 Oct 2006 06:16:36 -0000	1.19
+++ src/language/data-io/get.c	1 Nov 2006 04:17:21 -0000
@@ -1089,7 +1089,7 @@ cmd_match_files (struct dataset *ds)
             goto error;
           }
         iter->in_var->print = iter->in_var->write
-          = make_output_format (FMT_F, 1, 0);
+          = fmt_for_output (FMT_F, 1, 0);
       }
     
   /* MATCH FILES performs an n-way merge on all its input files.
